#ifndef ESP8266_PowerSave_h
#define ESP8266_PowerSave_h

#include <SoftwareSerial.h>
#include <Arduino.h>

class ESP8266_PowerSave {
  public:
            ESP8266_PowerSave(uint8_t rx, uint8_t tx) : esp(rx, tx) { rx_pin=rx; tx_pin=tx; };
    void    setup(uint8_t power, uint8_t enable, long spd);
    void    enable(void);
    void    disable(void);
    void    init(void);

    uint8_t connect_TCPIP(char *host, unsigned int port, uint8_t connect_retries);
    uint8_t is_connected_via_TCPIP(void);
    char    disconnect_TCPIP(void);
    char    power_on_and_wait_for_ip(char ip_timeout);
    int     TCPIP_send_receive(char *sendbuf, int sendbuf_len, char *recbuf, int recbuf_len);
    int     TCPIP_String_send_receive(char *sendbuf, char *recbuf, int recbuf_len);
    uint8_t get_TCPIP_status(void);

  private:
    uint8_t  power_pin;
    uint8_t  enable_pin;
    uint8_t  rx_pin;
    uint8_t  tx_pin;
    long     speed;
    uint8_t  enabled;

    SoftwareSerial  esp;

    void    emptyBuffer(void);
    char    wait_until_responsive(uint8_t timeout_seconds);
    char    wait_for_ip(char timeout_seconds);
    void    writeInt(unsigned int d);
    unsigned int getBinChecksum(char *buf, int len);
};

extern ESP8266_PowerSave esp8266;

#endif
